#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

#import <vesSharedPtr.h>

#import "mvesRenderer.h"


@interface mvesImageRepresentation : NSObject

- (id)initWithImage:(UIImage *)uiImage at:(double [3])c width:(double)w;

// coordinates of center
@property (nonatomic) double x;
@property (nonatomic) double y;
@property (nonatomic) double z;

// width
@property (nonatomic) double width;

// image opacity
@property (nonatomic) float opacity;

// renderer
- (void)addToRenderer:(vesSharedPtr<mvesRenderer>)r;
- (void)removeFromRenderer:(vesSharedPtr<mvesRenderer>)r;

// image
- (void)setImage:(UIImage *)img;

// set geoemetry
- (void)setCenter:(double[3])c;
- (void)scale:(double)s;
- (void)rotateByAngle:(double)a;
- (void)rotateByAngle:(double)a round:(double[3])axis;
- (void)setOrientation:(double[3])s1 v:(double[3])v;
- (void)translate:(double[3])p;

@end
