#ifndef mVES_mvesMaterials_h
#define mVES_mvesMaterials_h

#include "mvesShaderPrograms.h"

#include "vesBlend.h"
#include "vesDepth.h"
#include "vesTexture.h"

class mvesMaterials {
    
public:
    
    static vesSharedPtr<vesMaterial> gouraudMaterial() {
        vesSharedPtr<vesMaterial> material = vesSharedPtr<vesMaterial>(new vesMaterial());
        
        material->addAttribute(mvesShaderPrograms::gouraudShaderProgram());
        material->addAttribute(vesSharedPtr<vesBlend>(new vesBlend()));
        material->addAttribute(vesSharedPtr<vesDepth>(new vesDepth()));
        
        return material;
    }
    
    static vesSharedPtr<vesMaterial> gouraudTextureMaterial(vesSharedPtr<vesTexture> texture) {
        vesSharedPtr<vesMaterial> material = vesSharedPtr<vesMaterial>(new vesMaterial());
        
        material->addAttribute(mvesShaderPrograms::gouraudTextureShaderProgram());
        material->addAttribute(vesSharedPtr<vesBlend>(new vesBlend()));
        material->addAttribute(vesSharedPtr<vesDepth>(new vesDepth()));
        material->addAttribute(vesSharedPtr<vesTexture>(texture));
        
        return material;
    }

    static vesSharedPtr<vesMaterial> toonMaterial() {
        vesSharedPtr<vesMaterial> material = vesSharedPtr<vesMaterial>(new vesMaterial());
        
        material->addAttribute(mvesShaderPrograms::toonShaderProgram());
        material->addAttribute(vesSharedPtr<vesBlend>(new vesBlend()));
        material->addAttribute(vesSharedPtr<vesDepth>(new vesDepth()));
        
        return material;
    }
};


#endif
