#ifndef mvesPolyDataMapper_h
#define mvesPolyDataMapper_h

#include "vesMapper.h"

#include <vtkAlgorithmOutput.h>
#include <vtkAlgorithm.h>
#include <vtkPolyData.h>
#include <vtkScalarsToColors.h>
#include <vtkSmartPointer.h>


/// description:
/// A VES mapper for VTK polydata used to set up VTK style pipelines in VES.
class mvesPolyDataMapper : public vesMapper {
    
private:
    bool useTriangleFilter;
    vtkSmartPointer<vtkObject> timestamp;
    vtkSmartPointer<vtkAlgorithmOutput> input;
    vtkSmartPointer<vtkScalarsToColors> lookupTable;
    
public:
    mvesPolyDataMapper();

    void update();
    void SetInputConnection(vtkAlgorithmOutput *input);
    void SetInputData(vtkPolyData *input);
    void setLookupTable(vtkScalarsToColors *lut);
    vtkScalarsToColors *getLookupTable();
    
    bool isFilterTriangles();
    void setFilterTriangles(bool b);
    
    virtual void computeBounds();
    
    // convenience
    int countCells();
    void setColorA(float c[4]);
};

#endif

